Index: engine/jitc_pinvoke.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_pinvoke.c,v
retrieving revision 1.3
diff -c -r1.3 jitc_pinvoke.c
*** engine/jitc_pinvoke.c	28 Jul 2006 17:41:54 -0000	1.3
--- engine/jitc_pinvoke.c	16 Sep 2006 13:26:34 -0000
***************
*** 18,56 ****
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
  #define MARSHAL_FIRST_LEVEL_VALUE		0
  #define MARSHAL_ITEM_OF_STRUCTURE		1
  #define MARSHAL_ITEM_OF_ARRAY			2
  
- 
  static int NeedMarshalValue(ILType *type);
  static int NeedMarshalStruct(ILType *structureILType);
  
! static ILJitValue MarshalValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static ILJitValue MarshalStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
! 
! static ILJitValue MarshalReturnValue(jit_function_t function, ILJitValue in, ILType *type, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static ILJitValue MarshalReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
! 
! static void MarshalByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static void MarshalByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
! 
! void *ILJitDelegateGetClosure(ILExecThread *currentThread, ILObject *del, ILType *delType);
! 
! static ILJitValue MarshalDelegateValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread);
! static ILJitValue MarshalDelegateStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread);
  
! static ILJitValue MarshalDelegateReturnValue(jit_function_t function, ILJitValue in, ILType *type, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread);
! static ILJitValue MarshalDelegateReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread);
  
! static void MarshalDelegateByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread);
! static void MarshalDelegateByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind, ILExecThread *thread);
  
  /*
   * On demand code generator.for functions implemented in IL code.
   */
  static int _ILJitCompilePinvoke(jit_function_t func)
! {
  	ILMethod *method = (ILMethod *)jit_function_get_meta(func, IL_JIT_META_METHOD);
  	ILClass *info = ILMethod_Owner(method);
  	ILClassPrivate *classPrivate = (ILClassPrivate *)info->userData;
--- 18,62 ----
   * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   */
  
+ /*
+  * For enabling extended marshaling - of byref structures and arrays of structures uncomment the following define.
+  */
+ // #define USE_BYREF_MARSHALING 1
+ 
  #define MARSHAL_FIRST_LEVEL_VALUE		0
  #define MARSHAL_ITEM_OF_STRUCTURE		1
  #define MARSHAL_ITEM_OF_ARRAY			2
  
  static int NeedMarshalValue(ILType *type);
  static int NeedMarshalStruct(ILType *structureILType);
  
! static ILJitValue MarshalValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static ILJitValue MarshalStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
  
! static ILJitValue MarshalReturnValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static ILJitValue MarshalReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
! #ifdef USE_BYREF_MARSHALING
! static void MarshalByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static void MarshalByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
! #endif
! void *ILJitDelegateGetClosure(ILObject *del, ILType *delType);
  
! static ILJitValue MarshalDelegateValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
! static ILJitValue MarshalDelegateStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
  
+ static ILJitValue MarshalDelegateReturnValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
+ static ILJitValue MarshalDelegateReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
+ #ifdef USE_BYREF_MARSHALING
+ static void MarshalDelegateByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress);
+ static void MarshalDelegateByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind);
+ #endif
+ static void *MarshalObjectToCustom(void *value, ILType *type, ILMethod *method, ILExecThread *thread);
+ static void *MarshalCustomToObject(void *value, ILType *type, ILMethod *method, ILExecThread *thread);
  /*
   * On demand code generator.for functions implemented in IL code.
   */
  static int _ILJitCompilePinvoke(jit_function_t func)
! {	
  	ILMethod *method = (ILMethod *)jit_function_get_meta(func, IL_JIT_META_METHOD);
  	ILClass *info = ILMethod_Owner(method);
  	ILClassPrivate *classPrivate = (ILClassPrivate *)info->userData;
***************
*** 68,77 ****
  	ILJitType returnType = jit_type_get_return(signature);
  	ILJitValue returnValue = jit_value_create(func, jit_type_void_ptr);
  	unsigned int current;
- 	unsigned int typeFlag;
- 	ILJitValue newValue;
  	ILType *valueType;
! 
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS) && defined(_IL_JIT_ENABLE_DEBUG)
  	if(jitCoder->flags & IL_CODER_FLAG_STATS)
  	{
--- 74,86 ----
  	ILJitType returnType = jit_type_get_return(signature);
  	ILJitValue returnValue = jit_value_create(func, jit_type_void_ptr);
  	unsigned int current;
  	ILType *valueType;
! 	ILUInt32 marshalType;
! 	char *customName;
! 	int customNameLen;
! 	char *customCookie;
! 	int customCookieLen;
! 	
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS) && defined(_IL_JIT_ENABLE_DEBUG)
  	if(jitCoder->flags & IL_CODER_FLAG_STATS)
  	{
***************
*** 134,206 ****
  
  		default:
  		{
! 			/* There is an invalid calling convention inthe metadata. */
  			return JIT_RESULT_COMPILE_ERROR;
  		}
  	}
  
- 
  	ILJitType paramType;
  	ILJitType jitParamTypes[numParams + 1];
  	ILJitValue jitParams[numParams + 1];
  	ILJitValue tempParams[numParams + 1];
  	ILUInt32 param = 0;
! 
  	for(current = 1; current < numParams; ++current)
  	{
- 
  		paramType = jit_type_get_param(signature, current);
  		valueType = ILTypeGetParam(ilSignature, current);
  		valueType = ILTypeGetEnumType(valueType);
! 		tempParams[param] = jit_insn_dup(func, jit_value_get_param(func, current));
! 		jitParams[param] = (ILJitValue)MarshalValue(func, tempParams[param], valueType, current, 0, 0, 0);
  		jitParamTypes[param] = paramType;
  		++param;
  	}
  	ILJitType callSignature = jit_type_create_signature(jitAbi,
  								   returnType,
  								   jitParamTypes,
  								   numParams - 1, 1);
! 	if(numParams > 1)
! 	{														   
  		type = ILTypeGetEnumType(ILTypeGetReturn(ilSignature));
  		returnValue = jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
  								 callSignature,
  								 jitParams, numParams - 1, 0);
! 		jit_insn_store(func, returnValue, (ILJitValue)MarshalReturnValue(func, jit_insn_dup(func, returnValue), type, 0, 0, 0));
! 		param = 0;
! 		for(current = 1; current < numParams; ++current)
  		{
! 			newValue = jit_insn_dup(func, jitParams[param]);
! 			type = ILTypeGetParam(ilSignature, current);
! 			type = ILTypeGetEnumType(type);
  
! 			if(type!=0 && ILType_IsSimpleArray(type))
! 			{
! 				MarshalByRefValue(func, newValue, type, current, 0, 0, tempParams[param]);
  			}
! 			else if(type!=0 && ILType_IsComplex(type))
  			{
  				typeFlag = ILType_Kind(type);
! 		    		if(typeFlag==IL_TYPE_COMPLEX_BYREF || typeFlag == IL_TYPE_COMPLEX_PTR)
  				{
! 					MarshalByRefValue(func, newValue, type,
! 								    current, 0,
  								    0, tempParams[param]);
  				}
  			}
- 			++param;
  		}
! 		jit_insn_return(func, returnValue);
! 
! 	}
! 	else
! 	{
! 		jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
! 									callSignature, 0, 0, 0);
! 		jit_insn_return(func, 0);
  	}
! 	jit_type_free(callSignature);	
  
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS) && defined(_IL_JIT_ENABLE_DEBUG)
  #ifdef _IL_JIT_DUMP_FUNCTION
--- 143,300 ----
  
  		default:
  		{
! 			/* There is an invalid calling convention in the metadata. */
  			return JIT_RESULT_COMPILE_ERROR;
  		}
+ 		break;
  	}
  
  	ILJitType paramType;
  	ILJitType jitParamTypes[numParams + 1];
  	ILJitValue jitParams[numParams + 1];
  	ILJitValue tempParams[numParams + 1];
  	ILUInt32 param = 0;
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
  	for(current = 1; current < numParams; ++current)
+ 	
+ #else
+ 	for(current = 0; current < numParams; ++current)
+ #endif
  	{
  		paramType = jit_type_get_param(signature, current);
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  		valueType = ILTypeGetParam(ilSignature, current);
+ #else
+ 		valueType = ILTypeGetParam(ilSignature, current + 1);
+ #endif
  		valueType = ILTypeGetEnumType(valueType);
! 		tempParams[param] = jit_value_get_param(func, current);
! 		marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
! 								    &customCookie, &customCookieLen, valueType);
! 		jitParams[param] = jit_value_get_param(func, current);
! 		if(marshalType==IL_META_MARSHAL_CUSTOM)
! 		{
! 			ILJitValue params[4];
! 			params[0] = tempParams[param];
! 			params[1] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)valueType);
! 			params[2] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)method);
! 			params[3] = _ILJitFunctionGetThread(func);
! 			returnValue = jit_insn_call_native(func, "MarshalObjectToCustom", MarshalObjectToCustom, _ILJitSignature_MarshalObjectToCustom, params, 4, JIT_CALL_NOTHROW);
! 		}
! 		else if((!ILTypeIsStringClass(valueType) || marshalType!=IL_META_MARSHAL_DIRECT)
! 			    && NeedMarshalValue(valueType))
! 		{
! 			jitParams[param] = (ILJitValue)MarshalValue(func, tempParams[param], valueType, marshalType,
! 								    MARSHAL_FIRST_LEVEL_VALUE, 0, 0);
! 		}
  		jitParamTypes[param] = paramType;
  		++param;
  	}
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	if(numParams==2 && jitParamTypes[1]==jit_type_void)
+ 	{
+ 		numParams = 1;
+ 	}
+ #else
+ 	if(numParams==1 && jitParamTypes[0]==jit_type_void)
+ 	{
+ 		numParams = 0;
+ 	}
+ #endif
  	ILJitType callSignature = jit_type_create_signature(jitAbi,
  								   returnType,
  								   jitParamTypes,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  								   numParams - 1, 1);
! #else
! 								   numParams, 1);
! #endif
! 	if(returnType==jit_type_void)
! 	{
! 		jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
! 								callSignature,
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 								jitParams, numParams - 1, 0);
! #else
! 								jitParams, numParams, 0);
! #endif
! 	}
! 	else
! 	{
  		type = ILTypeGetEnumType(ILTypeGetReturn(ilSignature));
  		returnValue = jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
  								 callSignature,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  								 jitParams, numParams - 1, 0);
! #else
! 								 jitParams, numParams, 0);
! #endif
! 		marshalType = ILPInvokeGetMarshalType
! 				(0, method, 0, &customName, &customNameLen,
! 				 &customCookie, &customCookieLen, type);
! 		if(marshalType==IL_META_MARSHAL_CUSTOM)
! 		{
! 			ILJitValue params[4];
! 			params[0] = returnValue;
! 			params[1] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)type);
! 			params[2] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)method);
! 			params[3] = _ILJitFunctionGetThread(func);
! 			returnValue = jit_insn_call_native(func, "MarshalCustomToObject", MarshalCustomToObject, _ILJitSignature_MarshalCustomToObject, params, 4, JIT_CALL_NOTHROW);
! 		}
! 		else if((!ILTypeIsStringClass(type) || marshalType != IL_META_MARSHAL_DIRECT)
! 			    && NeedMarshalValue(type))
  		{
! 			returnValue = (ILJitValue)MarshalReturnValue(func, returnValue, type, marshalType,
! 									MARSHAL_FIRST_LEVEL_VALUE, 0, 0);
! 		}
! 	}
  
! #ifdef USE_BYREF_MARSHALING
! 	param = 0;
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 	for(current = 1; current < numParams; ++current)
! #else
! 	for(current = 0; current < numParams; ++current)
! #endif
! 	{
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 		type = ILTypeGetParam(ilSignature, current);
! #else
! 		type = ILTypeGetParam(ilSignature, current + 1);
! #endif
! 		type = ILTypeGetEnumType(type);
! 
! 		// Does anyone use this?
! 		marshalType = ILPInvokeGetMarshalType
! 					(pinv, method, current, &customName, &customNameLen,
! 					 &customCookie, &customCookieLen, type);
! 		if((!ILTypeIsStringClass(type) || marshalType != IL_META_MARSHAL_DIRECT) && NeedMarshalValue(type)
! 			&& marshalType != IL_META_MARSHAL_CUSTOM && type != 0)
! 		{
! 			if(ILType_IsSimpleArray(type))
! 			{
! 				 MarshalByRefValue(func, jitParams[param], type, 
! 							    marshalType, MARSHAL_FIRST_LEVEL_VALUE, 
! 							    0, tempParams[param]);
  			}
! 			else if(ILType_IsComplex(type))
  			{
  				typeFlag = ILType_Kind(type);
! 			    	if(typeFlag==IL_TYPE_COMPLEX_BYREF)
  				{
! 					// Does anyone use this?
! 					MarshalByRefValue(func, jitParams[param], type,
! 								    marshalType, MARSHAL_FIRST_LEVEL_VALUE,
  								    0, tempParams[param]);
  				}
  			}
  		}
! 		++param;
  	}
! #endif
! 	if(returnType==jit_type_void)jit_insn_return(func, 0);
! 	else jit_insn_return(func, returnValue);
! 	jit_type_free(callSignature);
  
  #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(IL_WITHOUT_TOOLS) && defined(_IL_JIT_ENABLE_DEBUG)
  #ifdef _IL_JIT_DUMP_FUNCTION
***************
*** 227,232 ****
--- 321,554 ----
  	return JIT_RESULT_OK;
  }
  
+ #if !defined(IL_CONFIG_REDUCE_CODE) && !defined(_IL_JIT_ENABLE_DEBUG)
+ static ILJitValue _ILJitInlinePinvoke(ILJITCoder *jitCoder, ILMethod *method, ILJitValue *tempParams)
+ {
+ 	ILJitFunction func = jitCoder->jitFunction;
+ 	ILJitMethodInfo *jitMethodInfo = (ILJitMethodInfo *)(method->userData);
+ 	ILType *ilSignature = ILMethod_Signature(method);
+ 	ILType *type;
+ 	ILJitType signature = jit_function_get_signature(ILJitFunctionFromILMethod(method));
+ 	ILPInvoke *pinv = ILPInvokeFind(method);
+ 	jit_abi_t jitAbi;
+ 	ILUInt32 numParams = jit_type_num_params(signature);
+ 	ILJitType returnType = _ILJitGetReturnType(ILTypeGetEnumType(ILTypeGetReturn(ilSignature)), jitCoder->process);
+ 	ILJitValue returnValue = jit_value_create(func, jit_type_void_ptr);
+ 	unsigned int current;
+ 	ILType *valueType;
+ 	ILUInt32 marshalType;
+ 	char *customName;
+ 	int customNameLen;
+ 	char *customCookie;
+ 	int customCookieLen;
+ 
+ 	if(!pinv)
+ 	{
+ 		/* The pinvoke record could not be found. */
+ 		return 0;
+ 	}
+ 
+ 	/* Setup the needed stuff in the jitCoder. */
+ 	jitCoder->jitFunction = func;
+ 
+ 	/* Check if the method to invoke was found on this system. */
+ 	if(_ILJitPinvokeError(jitMethodInfo->fnInfo))
+ 	{
+ 		if(jitMethodInfo->fnInfo.func == _IL_JIT_PINVOKE_DLLNOTFOUND)
+ 		{
+ 			_ILJitThrowSystem(jitCoder, _IL_JIT_DLL_NOT_FOUND);
+ 		}
+ 		else if(jitMethodInfo->fnInfo.func == _IL_JIT_PINVOKE_ENTRYPOINTNOTFOUND)
+ 		{
+ 			_ILJitThrowSystem(jitCoder, _IL_JIT_ENTRYPOINT_NOT_FOUND);
+ 		}
+ 		return 0;
+ 	}
+ 
+ 	/* determine which calling convention to use. */
+ 	switch(pinv->member.attributes & IL_META_PINVOKE_CALL_CONV_MASK)
+ 	{
+ 		case IL_META_PINVOKE_CALL_CONV_WINAPI:
+ 		{
+ 			/* TODO: There is no winapi calling convention in libjit. */
+ 			jitAbi = IL_JIT_CALLCONV_STDCALL;
+ 		}
+ 		break;
+ 
+ 		case IL_META_PINVOKE_CALL_CONV_CDECL:
+ 		{
+ 			jitAbi = IL_JIT_CALLCONV_CDECL;
+ 		}
+ 		break;
+ 
+ 		case IL_META_PINVOKE_CALL_CONV_STDCALL:
+ 		{
+ 			jitAbi = IL_JIT_CALLCONV_STDCALL;
+ 		}
+ 		break;
+ 
+ 		case IL_META_PINVOKE_CALL_CONV_FASTCALL:
+ 		{
+ 			jitAbi = IL_JIT_CALLCONV_FASTCALL;
+ 		}
+ 		break;
+ 
+ 		default:
+ 		{
+ 			/* There is an invalid calling convention inthe metadata. */
+ 			return 0;
+ 		}
+ 		break;
+ 	}
+ 
+ 	ILJitType paramType;
+ 	ILJitType jitParamTypes[numParams + 1];
+ 	ILJitValue jitParams[numParams + 1];
+ 	ILUInt32 param = 0;
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	for(current = 1; current < numParams; ++current)
+ #else
+ 	for(current = 0; current < numParams; ++current)
+ #endif
+ 	{
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 		paramType = _ILJitGetArgType(ILTypeGetEnumType(ILTypeGetParam(ilSignature, current)), jitCoder->process);
+ 		valueType = ILTypeGetParam(ilSignature, current);
+ #else
+ 		paramType = _ILJitGetArgType(ILTypeGetEnumType(ILTypeGetParam(ilSignature, current + 1)), jitCoder->process);
+ 		valueType = ILTypeGetParam(ilSignature, current + 1);
+ #endif	
+ 		valueType = ILTypeGetEnumType(valueType);
+ 		marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
+ 								    &customCookie, &customCookieLen, valueType);
+ 		jitParams[param] = tempParams[current];
+ 		if(marshalType==IL_META_MARSHAL_CUSTOM)
+ 		{
+ 			ILJitValue params[4];
+ 			params[0] = tempParams[current];
+ 			params[1] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)valueType);
+ 			params[2] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)method);
+ 			params[3] = _ILJitFunctionGetThread(func);
+ 			returnValue = jit_insn_call_native(func, "MarshalObjectToCustom", MarshalObjectToCustom,
+ 								_ILJitSignature_MarshalObjectToCustom, params, 4, JIT_CALL_NOTHROW);
+ 		}
+ 		else if((!ILTypeIsStringClass(valueType) || marshalType!=IL_META_MARSHAL_DIRECT)
+ 			    && NeedMarshalValue(valueType))
+ 		{
+ 			jitParams[param] = (ILJitValue)MarshalValue(func, tempParams[current], valueType, marshalType,
+ 									MARSHAL_FIRST_LEVEL_VALUE, 0, 0);
+ 		}
+ 		jitParamTypes[param] = paramType;
+ 		++param;
+ 	}
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	if(numParams==2 && jitParamTypes[0]==jit_type_void)
+ 	{
+ 		numParams = 1;
+ 	}
+ #else
+ 	if(numParams==1 && jitParamTypes[0]==jit_type_void)
+ 	{
+ 		numParams = 0;
+ 	}
+ #endif
+ 	ILJitType callSignature = jit_type_create_signature(jitAbi,
+ 								   returnType,
+ 								   jitParamTypes,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 								   numParams - 1, 1);
+ #else
+ 								   numParams, 1);
+ #endif
+ 	if(returnType==jit_type_void)
+ 	{
+ 		 jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
+ 								callSignature,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 								jitParams, numParams - 1, 0);
+ #else
+ 								jitParams, numParams, 0);
+ #endif
+ 	}
+ 	else
+ 	{
+ 		type = ILTypeGetEnumType(ILTypeGetReturn(ilSignature));
+ 		returnValue = jit_insn_call_native(func, 0, jitMethodInfo->fnInfo.func,
+ 								 callSignature,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 								 jitParams, numParams - 1, 0);
+ #else
+ 								 jitParams, numParams, 0);
+ #endif
+ 		marshalType = ILPInvokeGetMarshalType
+ 				(0, method, 0, &customName, &customNameLen,
+ 				 &customCookie, &customCookieLen, type);
+ 		if(marshalType==IL_META_MARSHAL_CUSTOM)
+ 		{
+ 			ILJitValue params[4];
+ 			params[0] = returnValue;
+ 			params[1] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)type);
+ 			params[2] = jit_value_create_nint_constant(func, _IL_JIT_TYPE_VPTR, (jit_nint)method);
+ 			params[3] = _ILJitFunctionGetThread(func);
+ 			returnValue = jit_insn_call_native(func, "MarshalCustomToObject", MarshalCustomToObject, _ILJitSignature_MarshalCustomToObject, params, 4, JIT_CALL_NOTHROW);
+ 		}
+ 		else if((!ILTypeIsStringClass(type) || marshalType != IL_META_MARSHAL_DIRECT) 
+ 			    && NeedMarshalValue(type))
+ 		{
+ 			returnValue = (ILJitValue)MarshalReturnValue(func, returnValue, type, marshalType,
+ 									MARSHAL_FIRST_LEVEL_VALUE, 0, 0);
+ 		}
+ 	}
+ 
+ #ifdef USE_BYREF_MARSHALING
+ 	param = 0;
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	for(current = 1; current < numParams; ++current)
+ #else
+ 	for(current = 0; current < numParams; ++current)
+ #endif
+ 	{
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 		type = ILTypeGetParam(ilSignature, current);
+ #else
+ 		type = ILTypeGetParam(ilSignature, current + 1);
+ #endif
+ 		type = ILTypeGetEnumType(type);
+ 
+ 		marshalType = ILPInvokeGetMarshalType
+ 					(pinv, method, current, &customName, &customNameLen,
+ 						&customCookie, &customCookieLen, type);
+ 		if((!ILTypeIsStringClass(type) || marshalType != IL_META_MARSHAL_DIRECT) && NeedMarshalValue(type)
+ 		    && marshalType != IL_META_MARSHAL_CUSTOM && type != 0)
+ 		{
+ 			if(ILType_IsSimpleArray(type))
+ 			{
+ 				// Does anyone use this?
+ 				MarshalByRefValue(func, jitParams[param], type, 
+ 							marshalType, MARSHAL_FIRST_LEVEL_VALUE, 
+ 							0, tempParams[current]);
+ 			}
+ 			else if(ILType_IsComplex(type))
+ 			{
+ 				typeFlag = ILType_Kind(type);
+ 			    	if(typeFlag==IL_TYPE_COMPLEX_BYREF)
+ 				{
+ 					// Does anyone use this?
+ 					MarshalByRefValue(func, jitParams[param], type,
+ 								    marshalType, MARSHAL_FIRST_LEVEL_VALUE,
+ 								    0, tempParams[current]);
+ 				}
+ 			}
+ 		}
+ 		++param;
+ 	}
+ #endif
+ 	if(returnType==jit_type_void)return 0;
+ 	else return(returnValue);
+ 	jit_type_free(callSignature);	
+ }
+ #endif // _ILJitInlinePinvoke
+ 
  static int NeedMarshalValue(ILType *type)
  {
      type = ILTypeGetEnumType(type);
***************
*** 334,349 ****
      {
  	    return 1;
      }
!     else if(ILType_IsClass(type))
!     {
! 	    return 0;
!     }
!     else if(type !=0 && ILType_IsComplex(type))
      {
- 	    
  	    switch(ILType_Kind(type))
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
  			    return 1;
--- 656,670 ----
      {
  	    return 1;
      }
!     else if(type!=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
+ 		    {
+ 			    return 0;
+ 		    }
+ 		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
  			    return 1;
***************
*** 366,372 ****
      	    return 1;
      }
  
!     return 1;
  }
  
  static int NeedMarshalStruct(ILType *structureILType)
--- 687,693 ----
      	    return 1;
      }
  
!     return 0;
  }
  
  static int NeedMarshalStruct(ILType *structureILType)
***************
*** 387,396 ****
  	return 0;
  }
  
! 
! static ILJitValue MarshalValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
-     ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      ILJitValue ptr, valuePtr;
      ILType *refType;
--- 708,715 ----
  	return 0;
  }
  
! static ILJitValue MarshalValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddressValue)
  {
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      ILJitValue ptr, valuePtr;
      ILType *refType;
***************
*** 408,439 ****
      ILJitValue newElemAddress;
      ILJitValue counter;
      ILJitValue arraySize;
-     ILUInt32 marshalType;
-     char *customName;
-     int customNameLen;
-     char *customCookie;
-     int customCookieLen;
-     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
-     ILPInvoke *pinv = ILPInvokeFind(method);
-     marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
- 							&customCookie,	&customCookieLen, type);
-     if(marshalType==IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE) 
-     {
-     	return in;
-     }
-     else if(marshalType==IL_META_MARSHAL_CUSTOM)
-     {
- 	    fprintf(stderr, "Custom marshaling not yet supported\n");
- 	    return 0;
-     }
- 
-     if(!NeedMarshalValue(type) && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
-     {
- 	    return in;
-     }    
      type = ILTypeGetEnumType(type);
!     if(addressKind==MARSHAL_ITEM_OF_ARRAY || addressKind == MARSHAL_ITEM_OF_STRUCTURE) outAddressValue = outAddress;
!     else if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE && addressKind!=MARSHAL_ITEM_OF_STRUCTURE)
      {
  	    fprintf(stderr, "addressKind has an invalid value of %d\n", addressKind);
  	    return 0;
--- 727,734 ----
      ILJitValue newElemAddress;
      ILJitValue counter;
      ILJitValue arraySize;
      type = ILTypeGetEnumType(type);
!     if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE && addressKind!=MARSHAL_ITEM_OF_STRUCTURE && addressKind!=MARSHAL_ITEM_OF_ARRAY)
      {
  	    fprintf(stderr, "addressKind has an invalid value of %d\n", addressKind);
  	    return 0;
***************
*** 576,592 ****
  			{
  				case MARSHAL_ITEM_OF_ARRAY:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  				}
  				break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  				}
  				break;
  				default:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
  				}
  				break;
  			}
--- 871,887 ----
  			{
  				case MARSHAL_ITEM_OF_ARRAY:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  				}
  				break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  				}
  				break;
  				default:
  				{
! 					return (ILJitValue)MarshalStruct(function, valuePtr, refType, marshalType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
  				}
  				break;
  			}
***************
*** 603,621 ****
  		default:  break;
  	}			
      }
!     else if (ILType_IsValueType(type))
      {
  	    switch(addressKind)
  	    {
  		    case MARSHAL_ITEM_OF_STRUCTURE:
  		    case MARSHAL_ITEM_OF_ARRAY:
  		    {
! 			    return (ILJitValue)MarshalStruct(function, in, type, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  		    }
  		    break;
  		    default:
  		    {
! 			    return (ILJitValue)MarshalStruct(function, jit_insn_address_of(function, in), type, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
  		    }
  		    break;
  	    }
--- 898,916 ----
  		default:  break;
  	}			
      }
!     else if(ILType_IsValueType(type))
      {
  	    switch(addressKind)
  	    {
  		    case MARSHAL_ITEM_OF_STRUCTURE:
  		    case MARSHAL_ITEM_OF_ARRAY:
  		    {
! 			    return (ILJitValue)MarshalStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_ARRAY);
  		    }
  		    break;
  		    default:
  		    {
! 			    return (ILJitValue)MarshalStruct(function, jit_insn_address_of(function, in), type, marshalType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
  		    }
  		    break;
  	    }
